Subject: Re: [bitcoin-dev] Block size following technological growth

From: Anthony Towns <[email-masked]>
Date: Mon, 3 Aug 2015 08:35:45 +1000

On Thu, Jul 30, 2015 at 12:20:30PM -0400, Gavin Andresen wrote:
> On Thu, Jul 30, 2015 at 10:25 AM, Pieter Wuille via bitcoin-dev
> > Some things are not included yet, such as a testnet whose size runs ahead
> > of the main chain, and the inclusion of Gavin's more accurate sigop
> > checking after the hard fork.
> First, THANK YOU for making a concrete proposal!
> So we'd get to 2MB blocks in the year 2021. I think that is much too
> conservative, and the most likely effect of being that conservative is that
> the main blockchain becomes a settlement network, affordable only for
> large-value transactions.

I haven't seen anyone do the (trivial) maths on this. Have I just
missed it? By my count:

 - blocks in 25 btc in rewards and about 0.5 btc in fees per block
 - at ~$300 USD per btc, that's ~$7,650 per block

 - current hashrate is ~400 PH/s; so ~240,000 PH/block works out
   to having to spend about 30PH per dollar earnt.
 - for comparison,
      https://products.butterflylabs.com/cloud-mining-contracts.html
    quotes $1.99 per GH/s for 12 months, which by my count is
      60*60*24*365 / 1.99 GH/$ = 15.8 PH per dollar spent
 - hashrate growth has slowed from about x4/quarter to x2/year:
     sep '13: ~1PH/s
     dec '13: ~4PH/s
     mar '14: ~20PH/s
     jun '14: ~80PH/s
     sep '14: ~200PH/s
     aug '15: ~400PH/s

 - so, as far as I understand it, miners don't make absurd profits compared
   to capital investment and running costs
 - presumably, then, miners will stop mining bitcoin if the revenue/block
   drops significantly at some point
 - less miners means a lower hashrate; a lower hashrate makes
   50% attacks easier, and that's a bad thing (especially if there's lots
   of pre-loved ASIC mining hardware available cheap on ebay or alibaba)

 - in about a year, the block reward halves, cutting out 12.5 btc or
   ~$3750 USD per block. without an increase in fees per block, miners
   will just get ~$3900 USD per block
 - the last time the reward for mining a block was under $4000 per block
   was around oct '13, with a hashrate of ~2PH/s

 - 13 btc in fees per block compared to .5 btc in fees per block is a
   25x increase; which could be either an increase in fee/txn or
   txns/block
 - with ~500 bytes/transaction, that's ~2000 transactions per MB
 - 13 btc in fees ($3900) per block means per transaction fees of
   about
     $2 for 1MB blocks
     $1 for 2MB blocks
     25c for 8MB blocks
     10c for 20MB blocks
   (assuming full blocks, 500 byte txns)

 - comparing that to credit card or paypal fees at ~2.5% that's:
    $2 -> minimum transaction  $80
    $1 -> minimum transaction  $40
    25c -> minimum transaction $10
    10c -> minimum transaction  $4

 - those numbers only depend on the USD/BTC exchange rate in so far as
   the more USD for a BTC, the more likely the block reward will pay
   for hashrate without transaction fees, even with the reward reduced
   to 12.5 btc/block. otherwise it's just USD/txn paying for USD/hashrate

 - the reference implementation fee of 0.1mBTC/kB equates to about
   3c per transaction (since it rounds up). Even 10c/transaction is more
   than a 3x increase on that.

What the above says to me is that even assuming everyone starts paying
fees, the lightning network works great, and so do sidechains and whatever
else, you /still/ want to up the volume of bitcoin txns by something like
an order of magnitude above what's currently allowed within a year or so.

Cheers,
aj